//boost::unordered_map<std::string, int, hash::fnv_1> dictionary;


#include <boost/unordered_set.hpp>
#include <iostream>

struct ihash/* : std::unary_function<int, std::size_t>*/
{
    std::size_t operator()(int const& x) const
    {
        return x%6;
    }
};


int main()
{
	typedef boost::unordered_set<int, ihash> unordered_set;
	unordered_set set;
	int bc = set.bucket_count();
	std::cout<<"Bucket count: "<<bc<<std::endl;
	for (int i = 0; i < 20; ++i)
	{
		set.insert(i);
		if (bc < set.bucket_count())
		{
			std::cout<<"Bucket count: "<<set.bucket_count()<<std::endl;
			bc = set.bucket_count();
		}
	}	
	

	std::cout<<std::endl;	
	//количество элементов в каждом разделе	
	for (int i = 0; i < set.bucket_count(); ++i)
		if (set.bucket_size(i) > 1)
			std::cout<< "Bucket "<<i<<": "<<set.bucket_size(i)<<std::endl;
	
	std::cout<<std::endl;
	//в каком разделе какой элемент
	for (int i = 0; i < 20; ++i)
		std::cout<<i<<" in bucket "<<set.bucket(i)<<std::endl;

	//elements in bucket3
	std::cout<<"Elements in bucket3:"<<std::endl;	
	for (unordered_set::local_iterator it = set.begin(3); it != set.end(3); ++it)
		std::cout<<*it<<std::endl;

	std::cout<<"Hash usage: "<<std::endl;
	for (int i = 0; i < 7; ++i)
		std::cout << set.hash_function()(i) << std::endl;
	return 0;
}
