#include <boost/unordered_map.hpp> 
#include <iostream> 
#include <string> 

int main() 
{ 
/*	typedef boost::unordered_map<std::string, int> unordered_map; 
	unordered_map map; 
	map.insert(unordered_map::value_type("One", 1)); 
	map.insert(unordered_map::value_type("Two", 2)); 
	map["Three"] = 3;
	map["Four"] = 4;
	map["Four"] = 4;
	std::cout<<map.at("One")<<std::endl;
	std::cout<<map["One"]<<std::endl;

	for (unordered_map::iterator it = map.begin(); it != map.end(); ++it) 
		std::cout << it->first << ", " << it->second << std::endl; 

	std::cout << map.size() << std::endl; 
	std::cout << map.max_size() << std::endl; 

	std::cout << (map.find("Five") != map.end()) << std::endl; 
	std::cout << map.count("Four") << std::endl; 
*/
	typedef boost::unordered_multimap<std::string, int> unordered_multimap; 
	unordered_multimap map; 
	map.insert(unordered_multimap::value_type("One", 1)); 
	map.insert(unordered_multimap::value_type("Two", 2));
	map.insert(unordered_multimap::value_type("Three", 3)); 
	map.insert(unordered_multimap::value_type("Four", 41)); 
	map.insert(unordered_multimap::value_type("Four", 42));
	map.insert(unordered_multimap::value_type("Four", 43)); 
	map.insert(unordered_multimap::value_type("Four", 42));

	std::cout << "Elements:" << std::endl;
 	for (unordered_multimap::iterator it = map.begin(); it != map.end(); ++it) 
		std::cout << it->first << ", " << it->second << std::endl; 


	std::cout << "Four elements:" << std::endl;
	for (unordered_multimap::local_iterator it = map.begin(map.bucket("Four")); it != map.end(map.bucket("Four")); ++it)
		std::cout<<it->first<<" "<<it->second<<std::endl;

	unordered_multimap::iterator it2 = map.erase(map.begin());
	std::cout << "Next after deleted:" << std::endl;
	std::cout << it2->second << std::endl;
	
	size_t quantity = map.erase("Four");
	std::cout << quantity <<" elements deleted"<< std::endl;
	std::cout << "Elements in multimap:" << std::endl;
	for (unordered_multimap::iterator it = map.begin(); it != map.end(); ++it) 
		std::cout << it->first << ", " << it->second << std::endl; 
	

} 
