#include <boost/unordered_set.hpp> 
#include <iostream> 
#include <string> 

int main() 
{ 
	typedef boost::unordered_set<std::string> unordered_set; 
	unordered_set set;
	set.insert("One"); 
	set.insert("Two"); 
	set.insert("Tree");
	set.insert("Four");
	set.insert("Five");
	set.insert("Two");

	for (unordered_set::iterator it = set.begin(); it != set.end(); ++it) 
		std::cout << *it << std::endl; 
	std::cout<<std::endl;
	
	std::cout << set.size() << std::endl; 
	std::cout << set.max_size() << std::endl; 

	std::cout << (set.find("Ten") != set.end()) << std::endl; 
	std::cout << set.count("Two") << std::endl; 
} 
